<!--
<publish-set
  :editRow="editRow"
  :publishShow="publishShow"
  @hidePublishDialog="hidePublishDialog">
</publish-set>

import publishSet from '@/components/api/publish-set.vue'
 -->
<template>
  <div v-show="customDialog">
    <el-dialog
      class="edit-dialog"
      title="发布"
      :visible.sync="customDialog"
      width="600px"
      :before-close="handleClose">
      <div class="edit-dialog-body">
        <el-form
          ref="publishForm"
          :model="formData"
          label-width="160px"
          :rules="rules">
          <el-form-item label="API名称:">
            {{ $route.query.interfaceName }}
          </el-form-item>
          <el-form-item label="发布环境:">
            {{ formData.sceneName }}
          </el-form-item>
          <el-form-item label="设置为默认版本:">
            <el-switch
              v-model="formData.defaultFlag"
              active-text=""
              inactive-text="" />
          </el-form-item>
          <el-form-item label="备注:">
            <limit-textarea
              :input-width="370"
              :input-value.sync="formData.remark"
              :holder="'请输入备注内容'"
              :get-by-type="'word'"
              :max-length="100" />
          </el-form-item>
        </el-form>
      </div>
      <div
        slot="footer"
        class="dialog-footer"
        style="padding-bottom: 10px;">
        <el-button @click="customCancel">
          取 消
        </el-button>
        <el-button
          type="primary"
          @click="customConfirm('publishForm')">
          发 布
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import limitTextarea from '@/components/limit-textarea.vue';
import { getRequest } from '@/api/api';
import showMsg from '@/assets/js/showmsg';
import errMsg from '@/assets/js/error';
export default {
  name: 'PublishSet',
  components: {
    limitTextarea
  },
  props: {
    publishShow: {
      type: Boolean,
      default: false
    },
    editRow: {
      type: Object,
      default() {
        return {
          interfaceVersionId: '',
          version: '',
          status: '', // 0 删除 1更新修改 2发布 3 历史发布版本
          description: '',
          proxyType: '',
          defaultFlag: false,
          sceneCode: '',
          sceneName: '',
          remark: ''
        };
      }
    }
  },
  data() {
    return {
      customDialog: false, // 弹框显示
      formData: {
        interfaceVersionId: '',
        version: '',
        status: '', // 0 删除 1更新修改 2发布 3 历史发布版本
        description: '',
        proxyType: '',
        defaultFlag: false,
        sceneCode: '',
        sceneName: '',
        remark: ''
      },
      rules: {}
    };
  },

  /* 接收数据 */
  mounted() {
    const that = this;
    that.customDialog = that.publishShow;
    that.formData = JSON.parse(JSON.stringify(that.editRow));
    that.formData.defaultFlag = that.editRow.defaultFlag == 1 ? true : false;
  },
  methods: {
    /**
     * @description: 关闭
     * @param {Function} done
     * @author: 无尘
     */
    handleClose(done) {
      const that = this;
      done();
      that.hideDialog();
    },

    /**
     * @description: 取消
     * @author: 无尘
     */
    customCancel() {
      const that = this;
      that.hideDialog();
    },

    hideDialog() {
      const that = this;
      that.customDialog = false;
      that.$emit('hidePublishDialog');
      /* that.$nextTick(() => {
        that.formData.classifyName = '';
      }); */
    },

    /**
     * @description: 确定同步
     * @param {String} formName
     * @author: 无尘
     */
    customConfirm(formName) {
      const that = this;
      that.$refs[formName].validate(valid => {
        if (valid) {
          that.postEditData();
        } else {
          return false;
        }
      });
    },
    postEditData() {
      const that = this;
      let para = {
        interfaceVersionId: that.formData.interfaceVersionId,
        defaultFlag: that.formData.defaultFlag ? '1' : '0',
        remark: that.formData.remark
      };
      getRequest('/gateway-manage/publish-api', para)
        .then(res => {
          let resData = res.data;
          if (resData.code == '0000') {
            showMsg.showmsg('发布成功', 'success');
            that.setData();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * @description: 提交数据
     * @author: 无尘
     */
    setData() {
      const that = this;
      that.$emit('hidePublishDialog', true);
    }
  },
  watch: {
    publishShow: function(newData, oldData) {
      const that = this;
      that.customDialog = newData;
    },
    editRow: function(newData, oldData) {
      const that = this;
      that.formData = JSON.parse(JSON.stringify(newData));
      that.formData.defaultFlag = newData.defaultFlag == 1 ? true : false;
    }
  }
};
</script>

<style lang="less" scoped>
.edit-dialog {
  /deep/ .el-dialog__body {
    padding: 2px 55px 0 34px;
  }

  /deep/ .el-dialog__footer {
    border: none;
    padding-top: 3px;
  }

  &__title {
    width: 100%;
    height: 38px;
    padding: 12px 15px;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    background: rgba(235, 238, 245, 1);
  }

  .el-alert--info {
    width: 400px;
    font-size: 14px;
    color: #606266;
    background: #e6f7ff;
    border: 1px solid rgba(145, 213, 255, 1);
  }
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #1890ff;
  }
  .el-form {
    margin-top: 40px;
  }
}
</style>
